#include "main.h"

volatile uint8_t flag;

//zeit: wartezeit in ms (0 bis 65536)
void wait(uint16_t zeit) 
{
	uint16_t i;
    for(i=0;i<zeit;i++) _delay_ms(1); 		//da fr _delay_ms max Takt-abhngige Werte erlaubt
} 


int main(void) {

	uint8_t error=0;
	int16_t value=0;
	char s[20]={'0'};

	lcd_init();	
	lcd_clear();

	max127_init();

    // 16 bit timer:  
    TCCR1B = (1<<WGM12)|(1<<CS12)|(1<<CS10);// CTC + Prescaler 1024 --> CPU/1024
	// bei 16MHz und prescaler 1024 --> 1s
    OCR1A  = 15624;							//vorladen, f_comp=fosc/(prescaler*(OCRnX+1)); OCRnX=fosc/(f_comp*prescaler)-1
    TIMSK |= (1<<OCIE1A);        			//Output Compare Match A aktivieren

    // 8 bit timer:  
    TCCR2 = (1<<WGM21)|(1<<CS22)|(1<<CS21);	// CTC + Prescaler 256 --> CPU/256
	// bei 16MHz und prescaler 256 --> 2ms
    OCR2  = 124;							//vorladen, f_comp=fosc/(prescaler*(OCRnX+1)); OCRnX=fosc/(f_comp*prescaler)-1
    TIMSK |= (1<<OCIE2);        			//Output Compare Match aktivieren


	DDRD |= (1<<PD5) | ( 1 << PD6 );


	flag = 0;
	sei();

	while (1) { 		
		if ( flag==1) {			
			error=get_adc(1,0,&value);
			if (error!=true) {
				PORTD ^= ( 1 << PD6 );				
				set_cursor(0,2);
				itoa(value,s,10);
				lcd_sends(s);				
			}
			flag=0;			
		}
	}
return 1;
}

//((PORTD & ( 1 << PD5 ))>>PD5)

// bei 16MHz und prescaler 1024 --> 1s
ISR (TIMER1_COMPA_vect)
{
	PORTD ^= ( 1 << PD5 );		//toggle PD5
	if ( flag==0) {flag=1;}
	OCR1A  = 15624;				//f_comp=fosc/(prescaler*(OCRnX+1))
}

// bei 16MHz und prescaler 256 --> 2ms
ISR (TIMER2_COMP_vect)
{
	OCR2  = 124;				//f_comp=fosc/(prescaler*(OCRnX+1))
	/*
	uart_timeout++;
	if (uart_timeout>250) {
		uart_timeout=0;
		PORTD ^= ( 1 << PD6 );
	}
	*/
}
